﻿Imports System
Imports System.IO
Imports System.Windows
Imports System.Windows.Controls
Imports Telerik.Reporting.Service.SilverlightClient

Partial Public Class MainPage
    Inherits UserControl

    Public Sub New()
        InitializeComponent()
    End Sub

    Private file As Stream

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button1.Click
        Dim fileDlg = New SaveFileDialog()
        fileDlg.Filter = "PDF files|*.pdf|All files|*.*"

        If fileDlg.ShowDialog() = True Then
            Me.file = fileDlg.OpenFile()
            Dim serviceClient = New ReportServiceClient(New Uri(App.Current.Host.Source, "../ReportService.svc"))
            serviceClient.RenderAsync("PDF", "ClassLibrary1.Report1, ClassLibrary1, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null", Nothing, Nothing)
            AddHandler serviceClient.RenderCompleted, AddressOf Me.serviceClient_RenderCompleted

        End If
    End Sub

    Private Sub serviceClient_RenderCompleted(ByVal sender As Object, ByVal e As RenderEventArgs)
        Dim result = e.RenderingResult
        If Me.file IsNot Nothing Then
            Me.file.Write(result.DocumentBytes, 0, result.DocumentBytes.Length)
            Me.file.Close()
            Me.file.Dispose()
            Me.file = Nothing
        End If
    End Sub

End Class